Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultExpressionBuilder.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultExpressionBuilder.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultExpressionBuilder.java	(revision 44198)
@@ -709,6 +775,21 @@
     }
 
     @Override
+    public String toString(Formatter<Value> formatter) {
+        return this.value.toString(formatter);
+    }
+
+    @Override
+    public Value toValue(String expression) {
+        try {
+            Code code = ExpressionUtils.compile(expression);
+            return code.toValue(this);
+        } catch(Throwable ex) {
+            return custom(expression);
+        }
+    }
+
+    @Override
     public void accept(Visitor visitor, VisitorFilter filter) {
         if( this.value == null) {
             return;
@@ -717,29 +798,29 @@
     }
 
     @Override
-    public boolean has_spatial_functions() {
-        return this.config.getBoolean(Config.has_spatial_functions);
+    public String quote_for_identifiers() {
+        return FORMAT_QUOTE_FOR_IDENTIFIERS;
     }
-
+    
     @Override
-    public GeometrySupportType geometry_support_type() {
-        return (GeometrySupportType) this.config.get(Config.geometry_type_support);
+    public String quote_for_strings() {
+        return FORMAT_QUOTE_FOR_STRINGS;
     }
-
+       
     @Override
     public String string(String s) {
-        String quote = this.config.getString(Config.quote_for_strings);
+        String quote = this.quote_for_strings();
 //        No se porque no esta disponible wrapIfMissing
 //        return StringUtils.wrapIfMissing(s,quote);
         if (s.startsWith(quote)) {
             return s;
         }
-        return quote + s + quote;
+        return quote + StringUtils.replace(s,quote,quote+quote) + quote;
     }
 
     @Override
     public String identifier(String id) {
-        String quote = this.config.getString(Config.quote_for_identifiers);
+        String quote = this.quote_for_identifiers();
 //        No se porque no esta disponible wrapIfMissing
 //        return StringUtils.wrapIfMissing(id,quote);
         if (id.startsWith(quote)) {
@@ -749,11 +830,6 @@
     }
 
     @Override
-    public String bytearray(byte[] data) {
-        return "DECODE('"+bytearray_hex(data)+"','hex')";
-    }
-    
-    @Override
     public String bytearray_hex(byte[] data) {
         StringBuilder builder = new StringBuilder();
         for (byte abyte : data) {
@@ -774,7 +850,7 @@
     }
     
     @Override
-    public Object getSRSId(IProjection projection) {
+    public Object srs_id(IProjection projection) {
         if( projection==null ) {
             return 0;
         }
@@ -782,8 +858,13 @@
     }
 
     @Override
+    public Constant bytearray(byte[] data) {
+        return new ConstantBase(data);
+    }
+    
+    @Override
     public Constant srs(IProjection projection) {
-        return constant(getSRSId(projection));
+        return constant(projection);
     }
 
     @Override
@@ -798,12 +879,13 @@
     
     @Override
     public Parameter parameter(String name) {
-        Parameters parameters = this.getParameters();
-        Parameter parameter = parameters.get(name);
-        if( parameter != null ) {
-            return parameter;
+        List<Parameter> parameters = this.parameters();
+        for (Parameter parameter : parameters) {
+            if( StringUtils.equalsIgnoreCase(name, parameter.name()) ) {
+                return parameter;
+            }
         }
-        parameter = this.parameter();
+        Parameter parameter = this.parameter();
         parameter.name(name);
         return parameter;
     }
@@ -824,29 +906,33 @@
     }
 
     @Override
-    public GeometryValue geometry(Geometry geom, IProjection projection) {
-        return new GeometryValueBase(geom, projection);
+    public Constant geometry(Geometry geom, IProjection projection) {
+        geom.setProjection(projection);
+        return new ConstantBase(geom);
     }
 
     @Override
-    public GeometryValue geometry(Geometry geom) {
+    public Constant geometry(Geometry geom) {
         if( geom.getProjection()==null ) {
             throw new IllegalArgumentException("The geometry does not have an associated projection. Use 'geometry(Geometry, IProjection)'.");
         }
-        return new GeometryValueBase(geom, geom.getProjection());
+        return new ConstantBase(geom);
     }
 
     @Override
-    public GeometryValue envelope(Envelope envelope, IProjection projection) {
-        return new GeometryValueBase(envelope.getGeometry(), projection);
+    public Constant envelope(Envelope envelope, IProjection projection) {
+        Geometry geom = envelope.getGeometry();
+        geom.setProjection(projection);
+        return new ConstantBase(geom);
     }
 
     @Override
-    public GeometryValue envelope(Envelope envelope) {
+    public Constant envelope(Envelope envelope) {
         if( envelope.getProjection()==null ) {
             throw new IllegalArgumentException("The envelope does not have an associated projection. Use 'envelope(Geometry, IProjection)'.");
         }
-        return new GeometryValueBase(envelope.getGeometry(), envelope.getProjection());
+        Geometry geom = envelope.getGeometry();
+        return new ConstantBase(geom);
     }
 
     @Override
@@ -854,6 +940,16 @@
         return new CustomBase(value);
     }
 
+    @Override
+    public Method method(Value instance, String name, Value... values) {
+        MethodBase method = new MethodBase(instance, name);
+        for (Value theValue : values) {
+            method.parameter(theValue);
+        }
+        return method;
+    }
+    
+    @Override
     public Function function(String name, Value... values) {
         FunctionBase func = new FunctionBase(name);
         for (Value theValue : values) {
@@ -870,20 +966,27 @@
         return func;
     }
 
+    @Override
+    public BinaryOperator binaryOperator(String name, Value leftOperand, Value rightOperand) {
+        return binaryOperator(name, null, leftOperand, rightOperand);
+    }
+    
     public BinaryOperator binaryOperator(String name, String format, Value leftOperand, Value rightOperand) {
         BinaryOperator operator = new BinaryOperatorBase(name, format);
-        operator.setLeft(leftOperand);
-        operator.setRight(rightOperand);
+        operator.left(leftOperand);
+        operator.right(rightOperand);
         return operator;
     }
 
     @Override
-    public List<Variable> getVariables() {
+    public List<Variable> variables() {
         final Set<Variable> vars = new HashSet<>();
         this.accept(new Visitor() {
             @Override
             public void visit(Visitable value) {
-                vars.add((Variable) value);
+                if( !vars.contains((Variable)value) ) {
+                    vars.add((Variable)value);
+                }
             }
         }, new ClassVisitorFilter(Variable.class));
         List<Variable> lvars = new ArrayList<>(vars);
@@ -891,75 +994,9 @@
         return lvars;
     }
 
-    private static class ParametersBase extends ArrayList<Parameter> implements Parameters {
-
-        private static final long serialVersionUID = -2188534574151780470L;
-
-        public ParametersBase() {
-            super();
-        }
-
-        public ParametersBase(Collection parameters) {
-            super(parameters);
-        }
-
-        @Override
-        public Parameter get(String name) {
-            if( name == null ) {
-                return null;
-            }
-            for (Parameter param : this) {
-                if( param.is_variable() || param.is_geometry_variable() ) {
-                    if( name.equalsIgnoreCase(param.getName()) ) {
-                        return param;
-                    }
-                }
-            }
-            return null;
-        }
-
-        
-        @Override
-        public String toString() {
-            boolean first = true;
-            StringBuilder builder = new StringBuilder();
-            builder.append("{ ");
-            for (Parameter param : this) {
-                if (!first) {
-                    builder.append(", ");
-                } else {
-                    first = false;
-                }
-                String s;
-                Object value = param.getValue();
-                if (value == null) {
-                    s = "null";
-                } else if (value instanceof String) {
-                    s = "'" + (String) value + "'";
-                } else {
-                    s = value.toString();
-                }
-                switch (param.getType()) {
-                    case Constant:
-                        builder.append(s);
-                        break;
-                    case Geometry:
-                        builder.append("(Geometry)");
-                    case Variable:
-                    default:
-                        builder.append(param.getName());
-                        builder.append(": ");
-                        builder.append(s);
-                }
-            }
-            builder.append(" }");
-            return builder.toString();
-        }
-    }
-
     @Override
-    public Parameters getParameters() {
-        final Parameters params = new ParametersBase();
+    public List<Parameter> parameters() {
+        final List<Parameter>  params = new ArrayList<>();
         this.accept(new Visitor() {
             @Override
             public void visit(Visitable value) {
@@ -968,11 +1005,60 @@
         }, new ClassVisitorFilter(Parameter.class));
         return params;
     }
-
+    
     @Override
-    public Function getAsGeometry(Value value) {
-        return builtin_function("ST_AsBinary", config.getString(Config.ST_AsBinary), value);
+    public List<String> parameters_names() {
+        List<String> params = new ArrayList<>();
+        for (Parameter param : parameters()) {
+            Object theValue = param.value();
+            String s;
+            switch(param.type()) {
+                case Constant:
+                    if( theValue==null ) {
+                        s = "NULL";
+                    } else if( theValue instanceof String ) {
+                        s = "'" + (String)theValue + "'";
+                        
+                    } else if( theValue instanceof byte[] ) {
+                        s = bytearray_0x((byte[]) theValue);
+                        
+                    } else {
+                        s = theValue.toString();
+                    }    
+                    break;
+                case Geometry:
+                    if( param.name()==null ) {
+                        s = bytearray_0x((byte[]) theValue);
+                    } else {
+                        s = "\"" + param.name() + "\"";
+                    }
+                    break;
+                case Variable:
+                default:
+                    s = "\"" + param.name() + "\"";
+            }
+//            if( !params.contains(s) ) { // Ojo que deben ir todos, incluso duplicados.
+                params.add(s);
+//            }
+        }
+        // Collections.sort(params); Ojo, no deben ordenarse.
+        return params;
     }
+    
+    @Override
+    public List<String> variables_names() {
+        List<String> vars = new ArrayList<>();
+        for (Variable var : this.variables()) {
+            vars.add(var.name());
+        }
+        Collections.sort(vars);
+        return vars;
+    }
+    
+    @Override
+    public Function as_geometry(Value value) {
+        return builtin_function(FUNCTION_ST_ASBINARY, FORMAT_ST_ASBINARY, value);
+    }
 
     @Override
     public ExpressionBuilder set(Value value) {
@@ -985,7 +1071,7 @@
         if (this.value == null) {
             return this.set(value);
         }
-        BinaryOperator operator = binaryOperator("AND", config.getString(Config.operator_AND), this.value, value);
+        BinaryOperator operator = binaryOperator(OPERATOR_AND, FORMAT_OPERATOR_AND, this.value, value);
         this.value = operator;
         return this;
     }
